Imports Syncfusion.Windows.Forms.Grid
Public Class Form1

    Private myCustomersTable As DataTable = New DataTable("Customers")
    Private mySet As DataSet = New DataSet("MySet")

#Region "Table Creation"
    Private Sub GenerateTable()



        Dim dca As DataColumn() = New DataColumn() {New DataColumn("Name", GetType(String)), New DataColumn("DOB", GetType(System.DateTime))}


        myCustomersTable.Columns.AddRange(dca)



        myCustomersTable.PrimaryKey = New DataColumn() {myCustomersTable.Columns("CustomerID")}
        myCustomersTable.BeginLoadData()
        myCustomersTable.LoadDataRow(New Object() {"James", "1/1/1970"}, False)
        myCustomersTable.LoadDataRow(New Object() {"John Steel", "1/1/1970"}, False)
        myCustomersTable.LoadDataRow(New Object() {"Elizabeth Lincoln", "1/1/1970"}, False)
        myCustomersTable.LoadDataRow(New Object() {"Yoshi Tannamuri", "1/1/1970"}, False)
        myCustomersTable.EndLoadData()


        mySet.Tables.Add(myCustomersTable)



    End Sub
#End Region


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.GenerateTable()

        Me.GridDataBoundGrid1.DataSource = Me.myCustomersTable

        Dim style As GridStyleInfo = Me.GridDataBoundGrid1.Binder.InternalColumns("DOB").StyleInfo
        style.ShowButtons = GridShowButtons.Hide
        style.Format = "MM/dd/yy"

        AddHandler GridDataBoundGrid1.Model.QueryCellFormattedText, AddressOf Model_QueryCellFormattedText


    End Sub

    Private Sub Model_QueryCellFormattedText(ByVal sender As Object, ByVal e As GridCellTextEventArgs)
        If e.Style.Format = "MM/dd/yy" Then
            If e.Style.Text.Length = 0 Then
                e.Text = "00/00/00"
            Else
                Dim dt As DateTime = DateTime.Parse(e.Style.Text)
                e.Text = dt.ToString("MM/dd/yy")
            End If
            e.Handled = True
        End If
    End Sub



    Private Sub GridDataBoundGrid1_CurrentCellKeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles GridDataBoundGrid1.CurrentCellKeyDown
        Dim cc As GridCurrentCell = Me.GridDataBoundGrid1.CurrentCell
        If Me.GridDataBoundGrid1(cc.RowIndex, cc.ColIndex).Format = "MM/dd/yy" Then
            If e.KeyCode = Keys.Back Or e.KeyCode = Keys.Delete Then
                e.Handled = True
            End If
        End If
    End Sub

    Private Sub GridDataBoundGrid1_CurrentCellKeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles GridDataBoundGrid1.CurrentCellKeyPress
        Dim cc As GridCurrentCell = Me.GridDataBoundGrid1.CurrentCell
        If Me.GridDataBoundGrid1(cc.RowIndex, cc.ColIndex).Format = "MM/dd/yy" Then
            If Not cc.IsEditing Then
                cc.BeginEdit(True)
                'Else
            End If

            Dim s As String = cc.Renderer.ControlText
            Dim tb As GridTextBoxControl = CType(IIf(TypeOf cc.Renderer.Control Is GridTextBoxControl, cc.Renderer.Control, Nothing), GridTextBoxControl)
            If tb.SelectionStart >= 10 Then
                e.Handled = True
            ElseIf Char.IsDigit(e.KeyChar) Then
                tb.SelectionLength = 1
                If tb.SelectionStart < s.Length AndAlso s.Chars(tb.SelectionStart) = "/"c Then
                    tb.SelectionStart += 1
                End If
            ElseIf e.KeyChar = "/"c Then
                Do While tb.SelectionStart < s.Length AndAlso s.Chars(tb.SelectionStart) <> "/"c
                    tb.SelectionStart += 1
                Loop
                tb.SelectionStart += 1
                e.Handled = True
            ElseIf (Not Char.IsControl(e.KeyChar)) Then
                e.Handled = True 'ignore other keys
            End If
            'End If
        End If
    End Sub

    Private Sub GridDataBoundGrid1_CurrentCellValidating(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles GridDataBoundGrid1.CurrentCellValidating
        Dim cc As GridCurrentCell = Me.GridDataBoundGrid1.CurrentCell
        If Me.GridDataBoundGrid1(cc.RowIndex, cc.ColIndex).Format = "MM/dd/yy" Then
            Dim dt As DateTime
            If (DateTime.TryParse(cc.Renderer.ControlText, dt)) Then
                cc.Renderer.Control.Text = dt.ToString("MM/dd/yy")
            Else
                If cc.Renderer.ControlText = "00/00/00" Then
                    cc.Renderer.StyleInfo.CellValue = Nothing
                Else
                    e.Cancel = True
                    cc.ErrorMessage = "Bad Date"
                End If
            End If
        End If
    End Sub
End Class
